/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is JIM.
 *
 * The Initial Developer of the Original Code is
 * Pawel Chmielowski <prefiks@o2.pl>
 *
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * Pawel Chmielowski <prefiks@o2.pl>
 *
 * ***** END LICENSE BLOCK ***** */

/**
 * io.CharsetCoder
 *
 *
 */

/**
 * CharsetCoder
 *
 * Constructor:
 *   CharsetCoder([charset])
 *
 * Fields:
 *   charset
 *
 * Methods:
 *   encode(data)
 *   decode(data);
 *
 */

function CharsetCoder(charset)
{
    this.__charset = charset;
    this.__converter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].
        getService(Components.interfaces.nsIScriptableUnicodeConverter);
}

CharsetCoder.prototype =
{
    encode: function(data)
    {
        if (this.__charset) {
            this.__converter.charset = this.__charset;
            return this.__converter.ConvertFromUnicode(data);
        }
        return data;
    },

    decode: function(data)
    {
        if (this.__charset) {
            this.__converter.charset = this.__charset;
            return this.__converter.ConvertToUnicode(data);
        }
        return data;
    },

    set charset(charset)
    {
        return this.__charset = charset;
    },

    get charset()
    {
        return this.__charset = charset;
    }
}
